/****************************************************************/
/*   Copyright (c) 1998 Dept. of Materials, ICSTM               */
/*   All Rights Reserved                                        */
/*   THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ICSTM       */
/*   The copyright notice above does not evidence any           */
/*   actual or intended publication of such source code,        */
/*   and is an unpublished work by Dept. of Materials, ICSTM.   */
/*   This material contains CONFIDENTIAL INFORMATION that       */
/*   is the property of Imperial College. Any use,              */
/*   duplication or disclosure not specifically authorized      */
/*   by Imperial College is strictly prohibited.                */
/****************************************************************/
/* This code is part of the umats routines developed at in the  */
/* Materials Processing Group, Dept. of Materials, ICSTM.       */
/*      email p.d.lee or r.atwood @ic.ac.uk for details         */
/****************************************************************/

/****************************************************************/
/* colour.h                                                     */
/* Header file defining colour lookup table for gif output      */
/****************************************************************/
/****************************************************************/
/* Written by Peter D. Lee & Robert C. Atwood, Imperial College */
/* Aug 16, 1998                                                 */
/****************************************************************/
/*RCS Id:$Id: colour.h 887 2006-03-01 18:21:01Z rcatwood $*/

#ifndef COLOUR_H
#define COLOUR_H

/* Define a set of 32 colours for gif output */
#define COLOUR_SIZE 32

char colours[32*3] = {
0xff, 0xff, 0xff,	/*black*/
0xff, 0x00, 0x00,	/*red*/
0x00, 0xff, 0x00,	/*green*/
0x00, 0x00, 0xff,	/*blue*/

0xff, 0xa0, 0xa0,	/*red*/
0xa0, 0xff, 0xa0,	/*green*/
0xa0, 0xa0, 0xff,	/*blue*/
0xff, 0xa0, 0xa0,	/*red*/
0xf0, 0xff, 0xa0,	/*green*/
0xa0, 0xf0, 0xff,	/*blue*/

0xff, 0xa0, 0xf0,	/*red*/
0xa0, 0xff, 0xf0,	/*green*/
0xf0, 0xa0, 0xff,	/*blue*/
0xff, 0xf0, 0x40,	/*red*/
0x40, 0xff, 0xf0,	/*green*/
0xf0, 0x40, 0xff,	/*blue*/

0xaf, 0x10, 0xa0,	/*red*/
0xa0, 0xaf, 0x10,	/*green*/
0x10, 0xa0, 0xaf,	/*blue*/
0x2f, 0xa0, 0xa0,	/*red*/
0xa0, 0x2f, 0xa0,	/*green*/
0xa0, 0xa0, 0x2f,	/*blue*/

0xf0, 0x10, 0xf0,	/*red*/
0xf0, 0x30, 0xf0,	/*green*/
0xf0, 0x70, 0xff,	/*blue*/
0x2f, 0xf0, 0xa0,	/*red*/
0xa0, 0xff, 0xa0,	/*green*/
0xa0, 0xf0, 0x2f,	/*blue*/

0xbf, 0x40, 0xa0,	/*red*/
0xbb, 0x4f, 0x10,	/*green*/
0xb0, 0x40, 0xaf,	/*blue*/
0xbf, 0x40, 0xb0,	/*red*/
} ;

/* colour for eutectic grain */
#define EUT_RED 0    /*black*/
#define EUT_GREEN 0 /*black*/
#define EUT_BLUE 0 /*black*/

#endif /* COLOUR_H */
/*
RCS Log:$Log$
RCS Log:Revision 11.1  2006/03/01 18:20:39  rcatwood
RCS Log:Merging polycomponent and gas with meltback
RCS Log:
RCS Log:Revision 10.2  2005/12/01 14:38:01  rcatwood
RCS Log:Merged xly_05 changes into the main trunk
RCS Log:Primarily involving melt-back
RCS Log:
RCS Log:Revision 10.1.2.2  2005/11/23 18:18:53  rcatwood
RCS Log:Result of merging mould_source and xly meltback+curvature 2d versions
RCS Log:
RCS Log:Revision 10.1  2005/11/03 11:56:46  rcatwood
RCS Log:New version number -- using mould_src as base
RCS Log:
RCS Log:Revision 8.1.16.2  2005/11/02 11:55:05  rcatwood
RCS Log:Fixing up the revision nubmer after loss of repository
RCS Log:
RCS Log:Revision 9.1  2003/08/14 14:38:35  rcatwood
RCS Log:Working merge with decentered/porosity/procast, also including
RCS Log:Ali Chirazi's multicomponent (not tested in this version)
RCS Log:
RCS Log:Revision 8.1  2002/10/17 17:01:01  rcatwood
RCS Log:New version number! for decentered/porosity merge! Alpha Version!
RCS Log:
RCS Log:Revision 7.0  2000/11/07 15:55:38  rcatwood
RCS Log:Multi Cell Pores added
RCS Log:
RCS Log:Revision 6.0  2000/09/25 18:03:37  rcatwood
RCS Log:After PORE_00 and NLM
RCS Log:
RCS Log:Revision 2.0  2000/08/02 10:21:56  rcatwood
RCS Log:Version used for pore paper runs
RCS Log:
RCS Log:Revision 1.1  2000/05/22 12:29:24  rcatwood
RCS Log:Fixed fs finish. Casolid to C from  W file. Global option
RCS Log:
RCS Log:Revision 5.1  2000/03/02 16:11:10  rcatwood
RCS Log:Merged xxu and rca versions
RCS Log:
RCS Log:Revision 5.0.2.1  2000/03/01 15:54:30  rcatwood
RCS Log:merged VAR and Multiblock updates. Not tested
RCS Log:
RCS Log:Revision 5.0.1.1  2000/02/22 19:04:27  rcatwood
RCS Log:Not yet tested
RCS Log:
RCS Log:Revision 4.3  1999/12/23 18:12:24  rcatwood
RCS Log:Version used for Mcwasp runs
RCS Log:
RCS Log:Revision 4.2  1999/12/23 18:09:21  rcatwood
RCS Log:Solute arrays migrated to structure.
RCS Log:
RCS Log:Revision 4.1  1999/12/16 13:33:44  rcatwood
RCS Log:Finalised improved use of RCS in all files.
RCS Log:
RCS Log:Revision 4.0.2.1  1999/12/16 12:37:36  rcatwood
RCS Log:Improving rcs id for all files, this may require several checkins to test.
RCS Log:
*/
