/****************************************************************/
/*      Copyright (c) 1998 Dept. of Materials, ICSTM            */
/*      All Rights Reserved                                     */
/*      THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ICSTM    */
/*      The copyright notice above does not evidence any        */
/*      actual or intended publication of such source code,     */
/*      and is an unpublished work by Dept. of Materials, ICSTM.*/
/*      This material contains CONFIDENTIAL INFORMATION that    */
/*      is the property of Imperial College. Any use,           */
/*      duplication or disclosure not specifically authorized   */
/*      by Imperial College is strictly prohibited.             */
/****************************************************************/
/* This code is part of the umats routines developed at in the  */
/* Materials Processing Group, Dept. of Materials, ICSTM.       */
/*      email p.d.lee or r.atwood @ic.ac.uk for details         */
/****************************************************************/
/*RCS Id:$Id: rcs_id.h 1005 2007-04-27 17:14:08Z  $*/

#ifndef RCS_ID_H
#define RCS_ID_H

extern char const *alloc_multicomp_c();
extern char const *checkgas_c();
extern char const *checks_c();
extern char const *fg_read_c();
extern char const *grain_functions_c();
extern char const *handlers_c();
extern char const *init_nuc_mould_c();
extern char const *rcs_id_bigblock_c();
extern char const *rcs_id_c();
extern char const *rcs_id_ca_histo_c();
extern char const *rcs_id_calc_sb_c();
extern char const *rcs_id_ca_solid_c();
extern char const *rcs_id_castats_c();
extern char const *rcs_id_ca_wrapper_c();
/*extern char const *rcs_id_checkblock_c();*/
extern char const *rcs_id_curvature_c();
extern char const *rcs_id_curvature_3D_c();
extern char const *rcs_id_find_max_c();
extern char const *rcs_id_find_nmols_c();
extern char const *rcs_id_findroot_c();
extern char const *rcs_id_freeblock_c();
extern char const *rcs_id_gaussdev_c();
extern char const *rcs_id_getxyz_c();
extern char const *rcs_id_initcube_c();
extern char const *rcs_id_initface_c();
extern char const *rcs_id_init_sb_neigh_c();
extern char const *rcs_id_nbhd_def_c();
extern char const *rcs_id_nuc_functions_c();
extern char const *rcs_id_nuc_lookup_c();
extern char const *rcs_id_open_sb_c();
extern char const *rcs_id_output_ex_c();
extern char const *rcs_id_output_img_c();
extern char const *rcs_id_pore_c();
extern char const *rcs_id_pore_routines_c();
extern char const *rcs_id_pore_setup_c();
extern char const *rcs_id_props_c();
extern char const *rcs_id_rand_square_c();
extern char const *rcs_id_rand_step_c();
extern char const *rcs_id_read_blocks_c();
extern char const *rcs_id_read_cap_ca_c();
extern char const *rcs_id_read_ctrl_c();
extern char const *rcs_id_readgeoplus_c();
extern char const *rcs_id_readmat_c();
extern char const *rcs_id_read_sb_c();
extern char const *rcs_id_recr_extra_c();
extern char const *rcs_id_sb_boundary_c();
extern char const *rcs_id_sb_ca_step_c();
extern char const *rcs_id_sb_diffuse_alloy_c();
extern char const *rcs_id_sb_diffuse_gas_c();
extern char const *rcs_id_sb_line_int_c();
extern char const *rcs_id_sb_nuc_c();
extern char const *rcs_id_sb_temp_calc_c();
extern char const *rcs_id_subblock_c();
extern char const *rcs_id_SurCellRoutines_c();
extern char const *rcs_id_thermo_trace_calc_c();
extern char const *rcs_id_thermo_trace_init_c();
extern char const *rcs_id_trans_interp_calc_c();
extern char const *rcs_id_wfact_r_calc_c();
extern char const *rcs_id_wfact_z_calc_c();
extern char const *rcs_id_write_blocks_c();
extern char const *read_ca_procast_c();
extern char const *safeopen_c();
extern char const *sb_decentred_step_c();
extern char const *sb_diffuse_alloy_decentred_c();
extern char const *setup_mould_src_function_c();
extern char const *setup_temp_func_c();
extern char const *step_output_c();
extern char const *window_move_c();
extern char const *write_bb_values_c();
extern char const *write_block_values_c();
extern char const *write_ctrl_values_c();
extern char const *write_matprop_values_c();
extern char const *write_nprop_values_c();
extern char const *write_POREprop_values_c();
extern char const *write_pprop_values_c();

extern char const *rcs_id_icopymat_c();
extern char const *rcs_id_fcopymat_c();

#ifdef PROCAST_CA
	extern char const *ca_feedback_c();
	extern char const *user_rtn_cell_c();
#endif /* PROCAST_CA */

#endif
/*
RCS Log:$Log$
RCS Log:Revision 11.1  2006/03/01 18:20:40  rcatwood
RCS Log:Merging polycomponent and gas with meltback
RCS Log:
RCS Log:Revision 10.2  2005/12/01 14:38:01  rcatwood
RCS Log:Merged xly_05 changes into the main trunk
RCS Log:Primarily involving melt-back
RCS Log:
RCS Log:Revision 10.1.2.3  2005/12/01 13:09:37  rcatwood
RCS Log:Fixed some implicit function declarations
RCS Log:
RCS Log:Revision 10.1.2.2  2005/11/23 18:18:53  rcatwood
RCS Log:Result of merging mould_source and xly meltback+curvature 2d versions
RCS Log:
RCS Log:Revision 10.1.2.1  2005/11/07 17:47:56  rcatwood
RCS Log:Branch uisng Xiao Li Yang final version
RCS Log:Revision 10.1  2005/11/03 11:56:47  rcatwood
RCS Log:New version number -- using mould_src as base
RCS Log:
RCS Log:Revision 8.1.12.2  2005/11/02 11:55:05  rcatwood
RCS Log:Fixing up the revision nubmer after loss of repository
RCS Log:
RCS Log:Revision 9.4.4.1  2004/09/02 12:49:20  rcatwood
RCS Log:Added rcs id to SurCell routines file
RCS Log:
RCS Log:Revision 9.4  2003/10/27 20:01:12  rcatwood
RCS Log:Harmonized header file cpp protection
RCS Log:Fixed filename bug for restart
RCS Log:
RCS Log:Revision 9.3  2003/10/16 13:56:38  rcatwood
RCS Log:*** empty log message ***
RCS Log:
RCS Log:Revision 9.2  2003/10/16 13:48:06  rcatwood
RCS Log:added rcs id routines
RCS Log:
RCS Log:Revision 9.1  2003/08/14 14:38:38  rcatwood
RCS Log:Working merge with decentered/porosity/procast, also including
RCS Log:Ali Chirazi's multicomponent (not tested in this version)
RCS Log:
RCS Log:Revision 8.1.6.2  2003/01/22 16:53:45  rcatwood
RCS Log:Almost working read_fg version
RCS Log:
RCS Log:Revision 8.1.6.1  2003/01/17 16:09:30  rcatwood
RCS Log:Before changing all CA_FLOAT to CA_CA_FLOAT
RCS Log:
RCS Log:Revision 8.1  2002/10/17 17:01:03  rcatwood
RCS Log:New version number! for decentered/porosity merge! Alpha Version!
RCS Log:
RCS Log:Revision 7.3  2002/10/17 16:52:38  rcatwood
RCS Log:Merge from branch: combined Robert (porosity) and Wei (decentered octahedron) versions
RCS Log:
RCS Log:Revision 7.2.14.2  2002/09/13 11:02:17  rcatwood
RCS Log:added file position pointer for each subblock data location
RCS Log:de-linted the program a bit
RCS Log:
RCS Log:Revision 7.2.14.1  2002/09/12 11:57:51  rcatwood
RCS Log:added rcs id for write blocks
RCS Log:
RCS Log:Revision 7.2  2001/03/13 11:48:33  rcatwood
RCS Log:fixed some comments and added sb_line_int id subroutine
RCS Log:
RCS Log:Revision 7.1  2000/11/07 19:33:49  rcatwood
RCS Log:Altered T_lists and pore_max_fs
RCS Log:
RCS Log:Revision 7.0  2000/11/07 15:55:38  rcatwood
RCS Log:Multi Cell Pores added
RCS Log:
RCS Log:Revision 6.1  2000/10/24 14:55:52  rcatwood
RCS Log:before changing pore
RCS Log:
RCS Log:Revision 6.0  2000/09/25 18:03:37  rcatwood
RCS Log:After PORE_00 and NLM
RCS Log:
RCS Log:Revision 2.0  2000/08/02 10:21:56  rcatwood
RCS Log:Version used for pore paper runs
RCS Log:
RCS Log:Revision 1.1  2000/05/22 12:29:24  rcatwood
RCS Log:Fixed fs finish. Casolid to C from  W file. Global option
RCS Log:
RCS Log:Revision 5.2  2000/05/04 18:36:45  rcatwood
RCS Log:Fixed fs finish. Casolid to C from  W file. Global option
RCS Log:
RCS Log:Revision 5.1  2000/03/02 16:11:10  rcatwood
RCS Log:Merged xxu and rca versions
RCS Log:
RCS Log:Revision 5.0.2.1  2000/03/01 15:54:30  rcatwood
RCS Log:merged VAR and Multiblock updates. Not tested
RCS Log:
RCS Log:Revision 5.0.1.1  2000/02/22 19:04:27  rcatwood
RCS Log:Not yet tested
RCS Log:
RCS Log:Revision 4.3  2000/02/16 10:51:47  rcatwood
RCS Log:Fixed grain structure
RCS Log:
RCS Log:Revision 4.2  1999/12/23 18:12:24  rcatwood
RCS Log:Version used for Mcwasp runs
RCS Log:
RCS Log:Revision 4.1  1999/12/16 13:33:44  rcatwood
RCS Log:Finalised improved use of RCS in all files.
RCS Log:
RCS Log:Revision 4.0.2.1  1999/12/16 12:40:23  rcatwood
RCS Log:Improving rcs id for all files, this may require several checkins to test.
RCS Log:
*/

